﻿
--But I can do
SELECT convert(numeric(30,10),0)
 
--These work 
select  TRY_PARSE('0.12345678901234' as numeric(30,10)) --truncates 0.1234567890
select  TRY_PARSE('0.0' as numeric(30,10))  --- 0.0000000000
 
--this works 
select convert(numeric(30,10),0)
 
-- now try this
select  TRY_PARSE('0' as numeric(30,10)) 
 
-- TRY_CONVERT works as well
select  TRY_CONVERT( numeric(30,10),'0')

-- With decimal point
SELECT TRY_PARSE('.0' AS NUMERIC(30,10)) -- Ok
SELECT TRY_PARSE('0.' AS NUMERIC(30,10)) -- Works

--All these work:
SELECT TRY_PARSE('0.000000000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.00000000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.0000000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.000000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.00000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.0000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.000' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.00' AS NUMERIC(30,10))
SELECT TRY_PARSE('0.0' AS NUMERIC(30,10))
 
--Interesting that this uses the CLR (like FORMAT).  

--No problem with these either
select  TRY_PARSE('-1' as numeric(30,10))
select  TRY_PARSE('1' as numeric(30,10))
select  TRY_PARSE('.' as numeric(30,10))
--it is just the 0 by itself

/*
Decimal support in PARSE/TRY_PARSE/FORMAT is bit tricky due to the mismatch of precision/scale between T-SQL and .NET. 
We had to do some special implementation on our side to match T-SQL functionality. 
This is a bug though. Please file it in connect and we will take a look at it.
 
Did you try below?
*/
 
select try_parse('+0' as numeric(30, 10));
select try_parse('-0' as numeric(30, 10));
select try_parse('+.' as numeric(30, 10));
select try_parse('-.' as numeric(30, 10));
 
select try_convert(numeric(30,10), '+0')
select try_convert(numeric(30,10), '-0')
select try_convert(numeric(30,10), '+.')
select try_convert(numeric(30,10), '-.')